#ifndef I2C_h
#define I2C_H

#ifdef __cplusplus
 extern "C" {
#endif


#include "stm32f10x_conf.h"

#define BUFFER_LENGTH 32

 //debugFlags
#define I2C_DebugFlag_Bit0 		0x00000001
#define I2C_DebugFlag_Bit1 		0x00000002
#define I2C_DebugFlag_Bit2 		0x00000004
#define I2C_DebugFlag_Bit3 		0x00000008
#define I2C_DebugFlag_Bit4 		0x00000010
#define I2C_DebugFlag_Bit5 		0x00000020
#define I2C_DebugFlag_Bit6 		0x00000040
#define I2C_DebugFlag_Bit7 		0x00000080
#define I2C_DebugFlag_Bit8 		0x00000100
#define I2C_DebugFlag_Bit9 		0x00000200
#define I2C_DebugFlag_Bit10 	0x00000400
#define I2C_DebugFlag_Bit11 	0x00000800
#define I2C_DebugFlag_Bit12		0x00001000
#define I2C_DebugFlag_Bit13		0x00002000
#define I2C_DebugFlag_Bit14		0x00004000
#define I2C_DebugFlag_Bit15		0x00008000
#define I2C_DebugFlag_Bit16		0x00010000
#define I2C_DebugFlag_Bit17		0x00020000
#define I2C_DebugFlag_Bit18		0x00040000
#define I2C_DebugFlag_Bit19		0x00080000
#define I2C_DebugFlag_Bit20		0x00100000
#define I2C_DebugFlag_Bit21		0x00200000
#define I2C_DebugFlag_Bit22		0x00400000
#define I2C_DebugFlag_Bit23		0x00800000
#define I2C_DebugFlag_Bit24		0x01000000
#define I2C_DebugFlag_Bit25		0x02000000
#define I2C_DebugFlag_Bit26		0x04000000
#define I2C_DebugFlag_Bit27		0x08000000
#define I2C_DebugFlag_Bit28		0x10000000
#define I2C_DebugFlag_Bit29		0x20000000
#define I2C_DebugFlag_Bit30		0x40000000
#define I2C_DebugFlag_Bit31		0x80000000




void i2c_handleEventInterrupt(void);
void i2c_handleEventInterrupt_ReadMethod1(void);
void i2c_handleErrorInterrupt(void);

void i2c_create(I2C_TypeDef * I2Cx);
void i2c_writeByte(uint8_t address, uint8_t byte);
void i2c_writeTwoBytes(uint8_t address, uint8_t byte1, uint8_t byte0);
void i2c_readTwoBytes(uint8_t address);
uint16_t i2c_getData(void);
void i2cbeginTransmission(uint8_t devAddr);
void i2csend(uint8_t data);
uint8_t i2cendTransmission(uint16_t timeout);
uint8_t i2cendTransmission_noTimeout(void);
uint8_t twii_WaitForDone(uint16_t timeout);




#ifdef __cplusplus
}
#endif

 extern I2C_TypeDef * I2C_Module;

extern volatile uint32_t i2c1_EV_ISR_Count;

 extern volatile uint8_t deviceAddress;
 extern volatile uint8_t regAddr;
 //volatile uint8_t regAddrToSend = 0;
 extern volatile uint8_t i2cDirectionWrite;
 extern volatile uint8_t i2cBusyFlag;
 //volatile uint8_t i2cReadDev = 0;

 //---------------------------
 // receive
 extern volatile uint8_t rxBuffer[BUFFER_LENGTH];
 extern volatile uint8_t rxBufferIndex;
 extern volatile uint8_t rxRemainCount;
 //volatile uint8_t rxLastPull = 0;
 //---------------------------


 //---------------------------
 // transmit
 extern volatile uint8_t txBuffer[BUFFER_LENGTH];
 extern volatile uint8_t txBufferIndex;
 extern volatile uint8_t txCount;
 //---------------------------

 //---------------------------
 //debug
 extern volatile uint32_t i2cDebug_EV_ISRanfang[50];
 extern volatile uint32_t i2cDebug_EV_ISRende[50];

 extern volatile uint32_t i2cDebug_EV_ISRanfang_DebugFlags[50];
 extern volatile uint32_t i2cDebug_EV_ISRende_DebugFlags[50];

 extern volatile uint8_t debugflag;
 //---------------------------



#endif
