#include "i2c.h"

I2C_TypeDef * I2C_Module;

//volatile uint8_t dataByte1;
//volatile uint8_t dataByte0;
//volatile uint8_t receivedDataByte1;
//volatile uint8_t receivedDataByte0;


//--------------------------------------------

volatile uint8_t deviceAddress;
volatile uint8_t regAddr;
//volatile uint8_t regAddrToSend = 0;
volatile uint8_t i2cDirectionWrite = 0;
volatile uint8_t i2cBusyFlag = 0;
//volatile uint8_t i2cReadDev = 0;

//---------------------------
// receive
volatile uint8_t rxBuffer[BUFFER_LENGTH];
volatile uint8_t rxBufferIndex = 0;
volatile uint8_t rxRemainCount = 0;
//volatile uint8_t rxLastPull = 0;
//---------------------------


//---------------------------
// transmit
volatile uint8_t txBuffer[BUFFER_LENGTH] = {9,9,9,9,9,9,9,9,9,9,   9,9,9,9,9,9,9,9,9,9,  9,9,9,9,9,9,9,9,9,9,	9,9};
volatile uint8_t txBufferIndex = 0;
volatile uint8_t txCount = 0;
//---------------------------

//---------------------------
//debug
volatile uint32_t i2cDebug_EV_ISRanfang[50]= {0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0    };
volatile uint32_t i2cDebug_EV_ISRende[50]= {0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0    };
volatile uint32_t i2cDebug_EV_ISRanfang_DebugFlags[50]= {0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0    };
volatile uint32_t i2cDebug_EV_ISRende_DebugFlags[50]= {0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0,    0,0,0,0,0,0,0,0,0,0    };
volatile uint8_t debugflag = 0;

volatile uint32_t i2c1_EV_ISR_Count = 0;
//---------------------------


// ISR neu

void i2c_handleEventInterrupt_ReadMethod1(void){

	if(i2c1_EV_ISR_Count < 25){
		i2cDebug_EV_ISRanfang[(i2c1_EV_ISR_Count* 2) +1] = I2C_Module->SR2;
		i2cDebug_EV_ISRanfang[(i2c1_EV_ISR_Count* 2)] = I2C_Module->SR1;

		i2cDebug_EV_ISRanfang_DebugFlags[i2c1_EV_ISR_Count] = debug32[3];
	}

	//const uint16_t readSR1 = I2C_ReadRegister(I2C_Module, I2C_Register_SR1);
	if(i2cDirectionWrite){
		debug32[3] |= (1 << 0);
		if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_SB) == SET){
			//SB EV
		   I2C_Send7bitAddress(I2C_Module, deviceAddress, I2C_Direction_Transmitter);
		   debug32[3] |= (1 << 1);
		}else if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_ADDR) == SET){
			//ADDR EV
			// EV6
			//I2C_ReadRegister(I2C_Module, I2C_Register_SR1); //unntig da bei der if-Bedingung SR1 schon gelesen wird
			I2C_ReadRegister(I2C_Module, I2C_Register_SR2);
			debug32[3] |= (1 << 2);
			//hier ist TXE schon gesetzt. aber Warum?



			if(rxRemainCount != 0){
				i2cDirectionWrite = 0;
				I2C_GenerateSTART(I2C_Module, ENABLE); //Start einstellen bevor Daten in DR geschrieben werden,
														// da sonst TXe nicht gelscht wird
				//I2C_SendData(I2C_Module, 0);
				debug32[3] |= (1 << 3);
			}
			// EV8_1
			I2C_SendData(I2C_Module, regAddr);

			//hier ist Startflag noch nicht gesetzt


		}else if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_TXE) == SET){
			debug32[3] |= (1 << 4);
			if(txCount != 0){
				debug32[3] |= (1 << 5);
				txCount--;
				I2C_SendData(I2C_Module, txBuffer[txBufferIndex++]);
				if(txCount  == 0){
				//letztes byte wurde in DR geschreiben
					 I2C_GenerateSTOP(I2C_Module, ENABLE);
					 debug32[3] |= (1 << 6);
				}
			}else if(rxRemainCount != 0){
				//wird momentan eh nicht ausgefhrt
				debug32[3] |= (1 << 7);
				i2cDirectionWrite = 0;

				//I2C_GenerateSTART(I2C_Module, ENABLE);
				//I2C_SendData(I2C_Module, 0); // um TXE mit Gewalt zu lschen
			}else if(txCount == 0){
				debug32[3] |= (1 << 8);
				i2cBusyFlag = 0;
			}
		}
	}else{
		//Receiver
		debug32[3] |= (1 << 9);
		if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_SB) == SET){
			debug32[3] |= (1 << 10);

			I2C_Send7bitAddress(I2C_Module, deviceAddress, I2C_Direction_Receiver);
		}else if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_ADDR) == SET){
			debug32[3] |= (1 << 11);


			//Clear ADDR_Flag
			//I2C_ReadRegister(I2C_Module, I2C_Register_SR1);
			I2C_ReadRegister(I2C_Module, I2C_Register_SR2);
			//while(1);
			//I2C_SendData(I2C_Module, 0); // um TXE mit Gewalt zu lschen
			//SingleByte Read
			if(rxRemainCount == 1){
				debug32[3] |= (1 << 12);

				I2C_AcknowledgeConfig(I2C_Module, DISABLE);
				I2C_GenerateSTOP(I2C_Module, ENABLE);
			}

			//hier sind alle Flags gelscht
			//RXNE Flag wird spter gesetzt

		}else if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_BTF) == SET){
			I2C_GenerateSTART(I2C_Module, ENABLE);
			//Clear BTF FLag
			I2C_ReadRegister(I2C_Module, I2C_Register_SR1);
			I2C_ReceiveData(I2C_Module);

		}else if(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_RXNE) == SET){
			debug32[3] |= (1 << 13);
			rxBuffer[txBufferIndex++] = I2C_ReceiveData(I2C_Module);


			--rxRemainCount;
			if(rxRemainCount <= 1){
				debug32[3] |= (1 << 14);
				I2C_AcknowledgeConfig(I2C_Module, DISABLE);
				I2C_GenerateSTOP(I2C_Module, ENABLE);
			}else if(rxRemainCount == 0){
				debug32[3] |= (1 << 15);
				i2cBusyFlag = 0;
			}
		}

	}
	//ledToggle();
	if(i2c1_EV_ISR_Count < 25){
		i2cDebug_EV_ISRende[(i2c1_EV_ISR_Count* 2) +1] = I2C_Module->SR2;
		i2cDebug_EV_ISRende[(i2c1_EV_ISR_Count* 2)] = I2C_Module->SR1;

		i2cDebug_EV_ISRende_DebugFlags[i2c1_EV_ISR_Count] = debug32[3];
	}

	++i2c1_EV_ISR_Count;


}

// ISR
void i2c_handleErrorInterrupt(void){
static uint32_t i2c_ER_ISR_Count;
	ledAn();
	if(i2c_ER_ISR_Count++ == 0){
		debug32[5] = I2C_Module->SR2;
		debug32[4] = I2C_Module->SR1;
	}


	I2C_ClearFlag(I2C_Module, I2C_FLAG_AF);
	I2C_ClearFlag(I2C_Module, I2C_FLAG_ARLO);
	I2C_ClearFlag(I2C_Module, I2C_FLAG_BERR);

	I2C_GenerateSTOP(I2C_Module, ENABLE);
	i2cBusyFlag = 0;
}
