/**
  ******************************************************************************
  * @file    main.c
  * @author  Ac6
  * @version V1.0
  * @date    01-December-2013
  * @brief   Default main function.
  ******************************************************************************
*/


#include "stm32f10x_conf.h"
#include "Serial.hpp"
#include "debug.h"
#include "I2Cdev.h"
#include "myPCA9685.h"

uint8_t i2cPCA_Adr = 0x40<<1;
#define MPU6050_DEFAULT_ADDRESS (0x68<<1)


PCA9685 motor0(0);
PCA9685 motor1(1);

int main(void)
{
	ledInit();
	serial.begin();

	serial.endl(5);
	serial.println("starting I2Cpp_test2...\n\r");

//#define i2cMPU_manualRead1
#define i2cMPU_manualRead2
//#define i2cPCA_manualRead


I2Cdev::init(5000, true);


	delay(2000);

		    serial.println("\n\r\n\rstarting...-------------\n\r");



#ifdef i2cMPU_manualRead1
		    uint8_t regADDR = 0x6B;
		    uint32_t whileCount = 0;
		    uint8_t nRead = 1;
		    uint8_t receive[nRead];
		    for(uint32_t a = 0; a < nRead; a++){
		    	receive[a] = 99;
		    }

		    while(1){
		    	delay(2000);
		    	serial.endl(2);
		    	serial.printlnVal("whileCount", ++whileCount,10);
				I2C_AcknowledgeConfig(I2C_Module, ENABLE);
				if(nRead == 2){
									I2C_NACKPositionConfig(I2C1, I2C_NACKPosition_Next);

								}

					serial.print("start generieren und warten...");
				//start generieren und warten
				I2C_GenerateSTART(I2C_Module, ENABLE);
				while(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_SB) == RESET);
				serial.println("done");

				//Slave adresse mit write senden und warten
				serial.print("Slave adresse mit write senden und warten...");
				I2C_Send7bitAddress(I2C_Module, MPU6050_DEFAULT_ADDRESS, I2C_Direction_Transmitter);


				while(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_ADDR) == RESET);
				//Write ADDR_Event
				I2C_ReadRegister(I2C_Module, I2C_Register_SR1);
				I2C_ReadRegister(I2C_Module, I2C_Register_SR2);
				serial.println("done");

				//RegisterAdress senden und warten
				serial.print("RegisterAdress senden und warten...");
				I2C_SendData(I2C_Module, regADDR);

				while(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_TXE) == RESET);
				serial.println("done");

				I2C_ReadRegister(I2C_Module, I2C_Register_SR1);
				I2C_ReadRegister(I2C_Module, I2C_Register_SR2);

				 //Restart
				serial.print("Restart...");


				I2C_GenerateSTART(I2C_Module, ENABLE);

				 while(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_SB) == RESET);
				 serial.println("done");

				 //device adresse mit read senden...
				 serial.print("device adresse mit read senden...");
				 I2C_Send7bitAddress(I2C_Module, MPU6050_DEFAULT_ADDRESS, I2C_Direction_Receiver);
				 while(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_ADDR) == RESET);
				//Read ADDR_Event
				 if(nRead == 1){
					 I2C_AcknowledgeConfig(I2C_Module, DISABLE);
				 }


				 // serial.println("done");

				 I2C_ReadRegister(I2C_Module, I2C_Register_SR1);
				 I2C_ReadRegister(I2C_Module, I2C_Register_SR2);

				 if(nRead == 1){
					 I2C_GenerateSTOP(I2C_Module, ENABLE);
				 }else if(nRead == 2){
					 I2C_AcknowledgeConfig(I2C_Module, DISABLE);
				 }else{

				 }

				 //serial.print("warten auf RXNE...");
				 uint8_t receiveCount = 0;
				 for(; receiveCount < nRead; receiveCount++){
					 if(nRead == 1){
						 while(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_RXNE) == RESET);
					 }else if(nRead == 2){
						 while(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_BTF) == RESET);
						 I2C_GenerateSTOP(I2C_Module, ENABLE);
						 receive[receiveCount++] = I2C_ReceiveData(I2C_Module);
					 }else if(nRead > 2 && receiveCount + 3 == nRead){
						 while(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_RXNE) == RESET);
						 while(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_BTF) == RESET);
						 I2C_AcknowledgeConfig(I2C_Module, DISABLE);
						 receive[receiveCount++] = I2C_ReceiveData(I2C_Module);
						 //while(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_RXNE) == RESET); // ???????
						 I2C_GenerateSTOP(I2C_Module, ENABLE);
						 receive[receiveCount++] = I2C_ReceiveData(I2C_Module);
						 while(I2C_GetFlagStatus(I2C_Module, I2C_FLAG_RXNE) == RESET);
					 }
					 receive[receiveCount] = I2C_ReceiveData(I2C_Module);
				 }
				 serial.endl();
				 serial.printlnVal("receiveCount", receiveCount);
				 serial.printlnValArray("receive", receive, nRead);

		    }




		uint8_t b;
		I2Cdev::readByte(MPU6050_DEFAULT_ADDRESS << 1,0x6B,&b);
		serial.println(b);
		while(1);
		I2Cdev::readByte(MPU6050_DEFAULT_ADDRESS << 1,0x6B,&b);
		serial.println(b);
#endif
#ifdef i2cMPU_manualRead2
		uint32_t whileCount = 0;
		for(uint16_t a = 0; a < 6; a++){
			i2cDebug_EV_ISRende[a*2] = 0;
			i2cDebug_EV_ISRende[(a*2)+ 1] = 0;
		}
		while(1){
			serial.printlnVal("i2c1_EV_ISR_Count", i2c1_EV_ISR_Count);
			delay(1000);
			serial.endl(2);
			serial.printlnVal("whileCount", ++whileCount,10);

			uint8_t b = 99;
			I2Cdev::readByte(MPU6050_DEFAULT_ADDRESS,0x6B,&b);
			delay(1000);
			serial.printlnVal("b", b);
			serial.printlnVal("i2c1_EV_ISR_Count", i2c1_EV_ISR_Count);


			for(uint16_t a = 0; a < 6; a++){
				serial.endl();
				serial.print("SRx und i2cDebug_DebugFlags bei ");
				serial.printlnVal("i2c1_EV_ISR_Count", a);

				serial.println("SRx ISRAnfang");
				serial.printlnVal("1", i2cDebug_EV_ISRanfang[a*2]);
				serial.printlnVal("2", i2cDebug_EV_ISRanfang[(a*2)+ 1]);
				serial.println("SRx ISREnde");
				serial.printlnVal("1", i2cDebug_EV_ISRende[a*2]);
				serial.printlnVal("2", i2cDebug_EV_ISRende[(a*2)+ 1]);

				i2cDebug_EV_ISRanfang[a*2] = 0;
				i2cDebug_EV_ISRanfang[(a*2)+ 1] = 0;
				i2cDebug_EV_ISRanfang[a*2] = 0;
				i2cDebug_EV_ISRanfang[(a*2)+ 1] = 0;

				serial.println("10987654321098765432109876543210");
				serial.println("i2cDebugISRanfang_DebugFlags ISRAnfang");
				serial.println(i2cDebug_EV_ISRanfang_DebugFlags[a], 2);

				serial.println("i2cDebugISRende_DebugFlags ISREnde");
				serial.println(i2cDebug_EV_ISRende_DebugFlags[a], 2);


			}

			serial.println("ISR_I2C_DebugFlags");
			serial.println("10987654321098765432109876543210");

			serial.println( debug32[3], 2);

			serial.println("ISRERROR");
							serial.printlnVal("1", debug32[4]);
							serial.printlnVal("2", debug32[5]);

			i2c1_EV_ISR_Count = 0;
			for(uint32_t a = 0; a < 20; a++){
				debug32[a] = 0;
			}

			b=0;
			while(1);
		}

#endif
#ifdef i2cPCA_manualRead
		uint32_t whileCount = 0;
				for(uint16_t a = 0; a < 6; a++){
					i2cDebug_EV_ISRende[a*2] = 0;
					i2cDebug_EV_ISRende[(a*2)+ 1] = 0;
				}
				while(1){
					serial.printlnVal("i2c1_EV_ISR_Count", i2c1_EV_ISR_Count);
					delay(1000);
					serial.endl(2);
					serial.printlnVal("whileCount", ++whileCount,10);

					uint8_t b = 99;
					I2Cdev::readByte(i2cPCA_Adr,0,&b);
					delay(1000);
					serial.printlnVal("b", b);
					serial.printlnVal("i2c1_EV_ISR_Count", i2c1_EV_ISR_Count);


					for(uint16_t a = 0; a < 6; a++){
						serial.endl();
						serial.print("SRx und i2cDebug_DebugFlags bei ");
						serial.printlnVal("i2c1_EV_ISR_Count", a);

						serial.println("SRx ISRAnfang");
						serial.printlnVal("1", i2cDebug_EV_ISRanfang[a*2]);
						serial.printlnVal("2", i2cDebug_EV_ISRanfang[(a*2)+ 1]);
						serial.println("SRx ISREnde");
						serial.printlnVal("1", i2cDebug_EV_ISRende[a*2]);
						serial.printlnVal("2", i2cDebug_EV_ISRende[(a*2)+ 1]);

						i2cDebug_EV_ISRanfang[a*2] = 0;
						i2cDebug_EV_ISRanfang[(a*2)+ 1] = 0;
						i2cDebug_EV_ISRanfang[a*2] = 0;
						i2cDebug_EV_ISRanfang[(a*2)+ 1] = 0;

						serial.println("10987654321098765432109876543210");
						serial.println("i2cDebugISRanfang_DebugFlags ISRAnfang");
						serial.println(i2cDebug_EV_ISRanfang_DebugFlags[a], 2);

						serial.println("i2cDebugISRende_DebugFlags ISREnde");
						serial.println(i2cDebug_EV_ISRende_DebugFlags[a], 2);


					}

					serial.println("ISR_I2C_DebugFlags");
					serial.println("10987654321098765432109876543210");

					serial.println( debug32[3], 2);

					serial.println("ISRERROR");
					serial.printlnVal("1", debug32[4]);
					serial.printlnVal("2", debug32[5]);

					serial.println("Einzel DebugVal");
					serial.printlnVal("__1SR1", debug32[18]);
					serial.printlnVal("__1SR2", debug32[19]);

					i2c1_EV_ISR_Count = 0;
					for(uint32_t a = 0; a < 20; a++){
						debug32[a] = 0;
					}

					b=0;
					while(1);
				}
#endif

	//mypca

		    serial.println("restallchannels...");
	motor0.restallchannels();

	serial.println("setPWMFreq...");
	motor0.setPWMFreq(50.0);
	//mypca ende

	while(1){


		serial.println("\n\nwhile...");
		delay(2000);


		motor0.setServoPWMprc(100.0);
		delay(2000);




		uint8_t empfang[20];
		I2Cdev::readBytes(i2cPCA_Adr, MODE1, 20, empfang);
		delay(2000);
		serial.printlnValArray("empfang", empfang, 20,10);
		serial.printlnValArray("txBuffer", txBuffer, 32,10);

		delay(2000);
		motor0.setServoPWMprc(0.0);
	}
}


