#include "myTim2.h"



volatile uint8_t timFlags;
volatile uint16_t tCountdown;
volatile uint32_t timeout;
volatile uint16_t tStoppuhr;
volatile uint16_t isrCount = 0;


void tim2enableInterrupt(void){
	TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE);

	NVIC_InitTypeDef NVIC_InitStructure;

	 NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
	  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x0F;
	  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0F;
	  NVIC_Init(&NVIC_InitStructure);


}
void tim2initNORMAL( uint16_t prs, uint16_t autoreload){
	 TIM_TimeBaseInitTypeDef TIM_TimeBase_InitStructure;
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);

	  TIM_TimeBase_InitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
	  TIM_TimeBase_InitStructure.TIM_CounterMode = TIM_CounterMode_Up;
	  TIM_TimeBase_InitStructure.TIM_Period = autoreload;
	  TIM_TimeBase_InitStructure.TIM_Prescaler = prs;
	  TIM_TimeBaseInit(TIM2, &TIM_TimeBase_InitStructure);

	  TIM_Cmd(TIM2, ENABLE);
}
uint8_t tim2askTimeout(void){
	 uint32_t countStandAktuell = TIM2->CNT;


	if(countStandAktuell < (uint32_t)tCountdown){
		countStandAktuell +=  TIM2->ARR;
	}
	if( countStandAktuell - tCountdown >= timeout ){
		tCountdown = countStandAktuell; // fr sptere Zwecke
		return 1;
	}
	return 0;
}
uint32_t tim2stoppuhr(uint8_t enable){

	if(enable){
		tStoppuhr = TIM2->CNT;
		return 0;
	}
	uint16_t rt = TIM2->CNT - tStoppuhr;

	return rt;// muss noch auf einheit ns skaliert werden
}
void tim2handleAll(){

}
uint8_t tim2setTimeout_us(uint32_t t_us){
 /// Achtung nur wenn SYSClock auf 72000000MHz luft stimmt das
	if(t_us == 0) return 1;
	const uint16_t countStandAktuell = TIM2->CNT;
	const uint16_t autoreload = TIM2->ARR;
	const uint32_t psc = TIM2->PSC + 1;
	uint32_t deltaCounts = (((uint32_t)72* t_us) + psc/2)  / psc;

	/*
	debug32[0] = countStandAktuell;
	debug32[1] = autoreload;
	debug32[2] = psc;
	debug32[3] = deltaCounts;
*/
	if(deltaCounts >= autoreload){
		//Fehler weil er nie soweit zhlen wird
		return 1;
	}

	tCountdown = countStandAktuell;
	timeout = deltaCounts;
	return 0;
}
void tim2Interrupthandler(void){
	TIM_ClearITPendingBit(TIM2, TIM_IT_Update);
	//ledToggle();
	isrCount++;
}
uint16_t millis(void){
	return isrCount;
}



//debug
uint16_t getCNT(void){
	//CountRegister
	return TIM2->CNT;
}
uint16_t getPSC(void){
	//Prescaler
	return TIM2->PSC;
}
//debug
uint16_t getRCR(void){
	return TIM2->RCR;
}
uint16_t getARR(void){
	return TIM2->ARR;
}
uint16_t getTimFlags(void){
	return 8;
}
uint16_t getTCountdown(void){
	return tCountdown;
}
uint16_t getTimeout(void){
	return timeout;
}
uint16_t getTStoppuhr(void){
	return tStoppuhr;
}

void delay(uint16_t t_ms){
	if( t_ms == 0) return;

	uint16_t alt_isrCount = isrCount;
	while((uint16_t)(isrCount - alt_isrCount) < t_ms );
}

